<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: TFTP.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">TFTP.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * TFTP.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: May 21, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_TFTP_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_TFTP_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#define TFTP_DEFAULT_PORT (69)</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;Socket.h&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classTFTP.html">   35</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTFTP.html">TFTP</a> {</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <a class="code" href="classTFTP.html">TFTP</a>();</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classTFTP.html">TFTP</a>();</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classTFTP.html#a8a8386ee01e4bad105cb1fee4e7aae51">start</a>(uint16_t port = TFTP_DEFAULT_PORT);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classTFTP.html#a13a7562a16fea3acabafc3c0811cabef">setBaseDir</a>(std::string baseDir);</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classTFTP_1_1TFTP__Transaction.html">   44</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classTFTP_1_1TFTP__Transaction.html">TFTP_Transaction</a> {</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <a class="code" href="classTFTP_1_1TFTP__Transaction.html#ab952bccc72460fbb123c8bfbd30b4a56">TFTP_Transaction</a>();</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classTFTP_1_1TFTP__Transaction.html#a98ea42d7912e6ccc33948e7adadf7259">processWRQ</a>();</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classTFTP_1_1TFTP__Transaction.html#a0b8e83b447d6c8321354a040f4f6a7c6">processRRQ</a>();</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classTFTP_1_1TFTP__Transaction.html#a46521d26eb68aac975fbb58e706804e8">sendAck</a>(uint16_t blockNumber);</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classTFTP_1_1TFTP__Transaction.html#a503c474a79b6b88c36b108bba9236e01">sendError</a>(uint16_t code, std::string message);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classTFTP_1_1TFTP__Transaction.html#ab1dc0909b4d9416f2148a0ba68453a76">setBaseDir</a>(std::string baseDir);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classTFTP_1_1TFTP__Transaction.html#a4aa35c73d2f586e07e63ee7746e75e9e">waitForAck</a>(uint16_t blockNumber);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        uint16_t <a class="code" href="classTFTP_1_1TFTP__Transaction.html#a107d19467cce9f8437e8af166737070a">waitForRequest</a>(<a class="code" href="classSocket.html">Socket</a>* pServerSocket);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <a class="code" href="classSocket.html">Socket</a> m_partnerSocket;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">struct </span>sockaddr m_partnerAddress;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        uint16_t    m_opCode; <span class="comment">// The last op code received.</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        std::string m_filename; <span class="comment">// The name of the file.</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        std::string m_mode;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        std::string m_baseDir; <span class="comment">// The base directory.</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    };</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    std::string m_baseDir;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;};</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_TFTP_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classTFTP_html_a13a7562a16fea3acabafc3c0811cabef"><div class="ttname"><a href="classTFTP.html#a13a7562a16fea3acabafc3c0811cabef">TFTP::setBaseDir</a></div><div class="ttdeci">void setBaseDir(std::string baseDir)</div><div class="ttdoc">Set the base dir for file access. If we are asked to put a file to the file system,...</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:281</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html_a4aa35c73d2f586e07e63ee7746e75e9e"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html#a4aa35c73d2f586e07e63ee7746e75e9e">TFTP::TFTP_Transaction::waitForAck</a></div><div class="ttdeci">void waitForAck(uint16_t blockNumber)</div><div class="ttdoc">Wait for an acknowledgment from the client. After having sent data to the client, we expect an acknow...</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:291</div></div>
<div class="ttc" id="classSocket_html"><div class="ttname"><a href="classSocket.html">Socket</a></div><div class="ttdoc">Encapsulate a socket.</div><div class="ttdef"><b>Definition:</b> Socket.h:62</div></div>
<div class="ttc" id="classTFTP_html_a8a8386ee01e4bad105cb1fee4e7aae51"><div class="ttname"><a href="classTFTP.html#a8a8386ee01e4bad105cb1fee4e7aae51">TFTP::start</a></div><div class="ttdeci">void start(uint16_t port=TFTP_DEFAULT_PORT)</div><div class="ttdoc">Start being a TFTP server.</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:228</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html_a503c474a79b6b88c36b108bba9236e01"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html#a503c474a79b6b88c36b108bba9236e01">TFTP::TFTP_Transaction::sendError</a></div><div class="ttdeci">void sendError(uint16_t code, std::string message)</div><div class="ttdoc">Send an error indication to the client.</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:382</div></div>
<div class="ttc" id="classTFTP_html"><div class="ttname"><a href="classTFTP.html">TFTP</a></div><div class="ttdoc">A TFTP server.</div><div class="ttdef"><b>Definition:</b> TFTP.h:35</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html_a46521d26eb68aac975fbb58e706804e8"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html#a46521d26eb68aac975fbb58e706804e8">TFTP::TFTP_Transaction::sendAck</a></div><div class="ttdeci">void sendAck(uint16_t blockNumber)</div><div class="ttdoc">Send an acknowledgment back to the partner. A TFTP acknowledgment packet contains an opcode (4) and a...</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:206</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html_a98ea42d7912e6ccc33948e7adadf7259"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html#a98ea42d7912e6ccc33948e7adadf7259">TFTP::TFTP_Transaction::processWRQ</a></div><div class="ttdeci">void processWRQ()</div><div class="ttdoc">Process a client write request.</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:151</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html_a107d19467cce9f8437e8af166737070a"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html#a107d19467cce9f8437e8af166737070a">TFTP::TFTP_Transaction::waitForRequest</a></div><div class="ttdeci">uint16_t waitForRequest(Socket *pServerSocket)</div><div class="ttdoc">Wait for a client request. A TFTP server waits for requests to send or receive files....</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:337</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html_ab1dc0909b4d9416f2148a0ba68453a76"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html#ab1dc0909b4d9416f2148a0ba68453a76">TFTP::TFTP_Transaction::setBaseDir</a></div><div class="ttdeci">void setBaseDir(std::string baseDir)</div><div class="ttdoc">Set the base dir for file access. If we are asked to put a file to the file system,...</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:270</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html_ab952bccc72460fbb123c8bfbd30b4a56"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html#ab952bccc72460fbb123c8bfbd30b4a56">TFTP::TFTP_Transaction::TFTP_Transaction</a></div><div class="ttdeci">TFTP_Transaction()</div><div class="ttdoc">Start a TFTP transaction.</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:73</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html_a0b8e83b447d6c8321354a040f4f6a7c6"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html#a0b8e83b447d6c8321354a040f4f6a7c6">TFTP::TFTP_Transaction::processRRQ</a></div><div class="ttdeci">void processRRQ()</div><div class="ttdoc">Process a client read request.</div><div class="ttdef"><b>Definition:</b> TFTP.cpp:86</div></div>
<div class="ttc" id="classTFTP_1_1TFTP__Transaction_html"><div class="ttname"><a href="classTFTP_1_1TFTP__Transaction.html">TFTP::TFTP_Transaction</a></div><div class="ttdoc">Internal class for TFTP processing.</div><div class="ttdef"><b>Definition:</b> TFTP.h:44</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
